// **********************************************************************
//	
//
// Programa de testes para manipulao de Imagens
//
//
//		Este programa deve ser compilador junto com a classe "ImageClass", 
//		que est implementada no arquivo "ImageClass.cpp"	
//
//		- para compilar no Visual C ou Visual Studio acrescente as seguintes
//        bibliotecas:
//					 opengl32.lib glu32.lib glaux.lib glut32.lib 
//
//		- para compilar no DEVCPP (ou no g++) acrescente as seguintes
//        bibliotecas:
//		      -lopengl32 -lglut32 -lglu32 -lglaux
//
//
//
//	Marcio Serolli Pinho
//	12/08/2003
//  pinho@inf.pucrs.br	
// **********************************************************************


#include <stdio.h>
#include <math.h>

#include <windows.h>

#include <GL\gl.h>
#include <GL\glaux.h>

#include "glut.h"

#include "ImageClass.h"


ImageClass *Image, *NovaImagem;

#define LIMIAR 5
// **********************************************************************
//  void ConvertBlackAndWhite()
//
//
// **********************************************************************
void ConvertBlackAndWhite()
{
// Tarefa 1:
//		Mude o valor do LIMIAR para nmero pequenos como 5 ou 10

	int x,y;

	for(x=0;x<Image->SizeX();x++)
	{
		for(y=0;y<Image->SizeY();y++)
        {
             if (Image->GetPointIntensity(x,y) < LIMIAR)
			 {
				NovaImagem->DrawPixel(x, y,0,0,0);
			 }
		}
	}

}

// **********************************************************************
// void ConvertToGrayScale()
//   
//
// **********************************************************************
void ConvertToGrayScale()
{
// Tarefa 2:
//		Gerar uma imagem em tons de cinza 
//		Use os mtodos 
//			'ReadPixel' e 'DrawPixel' da classe 'ImageClass'
	
//Image->ReadPixel(GLint x, GLint y, unsigned char &r, unsigned char &g, unsigned char &b)
// Obtm os valores R,G,B de um ponto X,Y da image

//Image->DrawPixel(GLint x, GLint y, unsigned char r, unsigned char g, unsigned char b)
	// Exibe na coordenada X,Y um ponto com a cor R,G,B na image 
}


// **********************************************************************
// void DetectImageBorders()
//   
//
// **********************************************************************
void DetectImageBorders()
{

	// varredura vertical

	// varredura horizontal

}
// **********************************************************************
// void AplicaMediana()
//   
//
// **********************************************************************
void AplicaMediana()
{

}

// **********************************************************************
// int Count(int x, int y)
//
//
// **********************************************************************
int CountNeighbours(int x, int y, ImageClass *I)
{
	return 0;
}

// **********************************************************************
// void MedianaFilter()
//
//
// **********************************************************************
void MedianaFilter()
{

}

// **********************************************************************
//  void init(void)
//		Inicializa os parmetros globais de OpenGL
//
// **********************************************************************
void init(void)
{
	Image = new ImageClass();
	int r;

	glClearColor(0.0f, 0.0f, 1.0f, 1.0f); // Fundo de tela preto

	r = Image->Load("B.bmp");

	if (!r)
		exit(1);
	NovaImagem = new ImageClass(Image->SizeX(), Image->SizeY());
	NovaImagem->SetPos(Image->SizeX()+10, 0);

}

// **********************************************************************
//  void reshape( int w, int h )
//		trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{

	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);
	gluOrtho2D(0,w,0,h);

	// Set the clipping volume
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();


}
// **********************************************************************
//  void display( void )
//
//
// **********************************************************************
void display( void )
{

	glClear(GL_COLOR_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	Image->Display();
	NovaImagem->Display();

	glutSwapBuffers();
}


// **********************************************************************
//  void keyboard ( unsigned char key, int x, int y )
//
//
// **********************************************************************
void keyboard ( unsigned char key, int x, int y )  
{

	switch ( key ) 
	{
		case 27:        // Termina o programa qdo
			exit ( 0 );   // a tecla ESC for pressionada
			break; 
		case '2': 
				ConvertBlackAndWhite();
				glutPostRedisplay();    // obrigratrio para redesenhar a tela
 				break;
		default:        
			break;
	}
}

// **********************************************************************
//  void arrow_keys ( int a_keys, int x, int y )  
//
//
// **********************************************************************
void arrow_keys ( int a_keys, int x, int y )  
{
	switch ( a_keys ) 
	{
		case GLUT_KEY_UP:       // When Up Arrow Is Pressed...
			glutFullScreen ( ); // Go Into Full Screen Mode
			break;
	    case GLUT_KEY_DOWN:     // When Down Arrow Is Pressed...
			glutInitWindowSize  ( 700, 500 ); 
			break;
		default:
			break;
	}
}

// **********************************************************************
//  void main ( int argc, char** argv )
//
//
// **********************************************************************
void main ( int argc, char** argv )   
{
	glutInit            ( &argc, argv ); 
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB );
	glutInitWindowPosition (0,0);
	glutInitWindowSize  ( 650, 500); 
	glutCreateWindow    ( "Image Border" ); 
		
	init ();
//	glutFullScreen();
	
	glutDisplayFunc ( display );  
	glutReshapeFunc ( reshape );
	glutKeyboardFunc ( keyboard );
	glutSpecialFunc ( arrow_keys );
	//glutIdleFunc ( display );

	glutMainLoop ( );          
}


